#include <stdio.h>
#include <string.h>
#include <wchar.h>

// агрегаты данных:
//-----------------------------------------------------

void test01( void ) {     // массив
   int ai[] = { 1, 2, 3, 4, 5 }, ni, j;
   printf( "%d элементов => ", ni = sizeof( ai ) / sizeof( ai[ 0 ] ) );
   for( j = 0; j < ni; j++ ) printf( "%d, ", ai[ j ] );
   printf( "\n" );
}

//-----------------------------------------------------

void test02( void ) {     // разница в представлении
   int ni, j;
   char ac[] = { '1', '2', '3', '4', '5', 0, '6', '\0' };
   printf( "%d элементов (строка длины %d) => ", 
           ni = sizeof( ac ) / sizeof( ac[ 0 ] ), strlen( ac ) );
   for( j = 0; j < ni; j++ ) printf( "%d, ", ac[ j ] );
   printf( "\n" );
}

//-----------------------------------------------------

void test03( void ) {
   struct ss {            // присвоение эквивалентных структурных данных
      int a1, a2, a3;
   } vss1 = { 1, 2, 3 }, vss2 = { 3, 2, 1 };
   char *put_ss( struct ss *pss ) {
      static char msg[ 40 ];
      sprintf( msg, "%d %d %d", pss->a1, pss->a2, pss->a3 );
      return msg;
   }
   printf( "было { %s }", put_ss( &vss1 ) );
   vss1 = vss2;
   printf( " ... стало { %s }\n", put_ss( &vss1 ) );
}

//-----------------------------------------------------

void test04( void ) {
   int j;
   struct su {            // наложение разнородныз данных
      union {
         char c[ 12 ];     
         short s[ 6 ];
         float f[ 3 ];
      };
   } su1 = {{{ '1', '2', '3', '4', '5', '6', 0, 0, 0, 0, 0, 0 }}};
   printf( "размер структуры %d байт\n", sizeof( su1 ) );
   printf( "как символы: " );
   for( j = 0; j < sizeof( su1.c ) / sizeof( su1.c[ 0 ] ); j++ )
      if( su1.c[ j ] != 0 ) printf( "%c, ", su1.c[ j ] );
      else printf( "\'\\0\', " );
   printf( "\nкак целые 8-бит: " );
   for( j = 0; j < sizeof( su1.c ) / sizeof( su1.c[ 0 ] ); j++ )
      printf( "%d, ", su1.c[ j ] );
   printf( "\nкак целые 16-бит: " );
   for( j = 0; j < sizeof( su1.s ) / sizeof( su1.s[ 0 ] ); j++ )
      printf( "%d, ", su1.s[ j ] );
   printf( "\nкак вещественные: " );
   for( j = 0; j < sizeof( su1.f ) / sizeof( su1.f[ 0 ] ); j++ )
      printf( "%f, ", su1.f[ j ] );
   printf( "\n" );
   char *p = (char*)&su1;
   printf( "адрес=%p : как строка %s, длиной %d символов\n",
           p, p, strlen( p ) );
}

//-----------------------------------------------------

void test05( void ) {
   // разница длины UTF-8 строки (русскоязычной) в байтах и символах
   const char buf[] = "русскоязычная строка";
   printf( "строка: '%s', длина %d ,байт\n", buf, strlen( buf ) );
}

//-----------------------------------------------------

void test06( void ) {
   struct list {             // массив структур
      char *s;
      int i;
      struct list *next;
   } a[] = {
      { "abcd", 1, a + 1 },
      { "efgh", 2, a + 2 },
      { "ijkl", 3, a }
   };
   int ni = sizeof( a ) / sizeof( a[ 0 ] ), j;
   printf( "массив из %d структур => ", ni );
   for( j = 0; j < ni; j++ ) 
      printf( "%s, ", a[ j ].s );
   printf( "\n" );
   struct list *pl = a;
   printf( "связный список из %d структур => ", ni );
   for( j = 0; j < ni; j++, pl = pl->next ) 
      printf( "%s, ", a[ j ].s );
   printf( "\n" );
   pl = a;
   printf( "кольцевой список => " );
   for( j = 0; j < ni * 2; j++, pl = pl->next ) 
      printf( "%s, ", pl->s );
   printf( "... ...\n" ); 
}

//-----------------------------------------------------

int main () {
   void ( *tests[] )( void ) = {  // последовательность тестов
      test01, test02, test03, test04, test05, test06
   };
   int i;
   for( i = 0; i < sizeof( tests ) / sizeof( tests[ 0 ] ); i++ ) {
      tests[ i ]();
      printf( "----------------------------------------\n" );
   }
   return 0;
}
